
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux系统驱动开发调试技术指南 / iVAN</title>

    <meta name="description" content="Linux系统驱动开发调试技术指南   一.使用printk 这是驱动开发中最朴实无华,同时也是最常用和有效的手段.scull驱动的main.c第338行如下,就是使用printk进行调试的例子,这样的例子相信大家在阅读驱动源码时随处可见. printk(KERN_ALERT &quot;wakeup by signal in process %dn&quot;, current-&gt;;pid); printk的功能与我们经常在应用程序中使用的printf是一样的,不同之处在于printk可以在打印字符串前面加上内核定义的宏, ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux系统驱动开发调试技术指南</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> 　　一、使用printk</p>
<p>　　这是驱动开发中最朴实无华，同时也是最常用和有效的手段。scull驱动的main.c第338行如下，就是使用printk进行调试的例子，这样的例子相信大家在阅读驱动源码时随处可见。</p>
<p>　　printk(KERN_ALERT "wakeup by signal in process %dn", current-&gt;;pid);</p>
<p>　　printk的功能与我们经常在应用程序中使用的printf是一样的，不同之处在于printk可以在打印字符串前面加上内核定义的宏，例如上面例子中的KERN_ALERT(注意：宏与字符串之间没有逗号):</p>
<p>　　#define KERN_EMERG ""</p>
<p>　　#define KERN_ALERT ""</p>
<p>　　#define KERN_CRIT ""</p>
<p>　　#define KERN_ERR ""</p>
<p>　　#define KERN_WARNING ""</p>
<p>　　#define KERN_NOTICE ""</p>
<p>　　#define KERN_INFO ""</p>
<p>　　#define KERN_DEBUG ""</p>
<p>　　#define DEFAULT_CONSOLE_LOGLEVEL 7</p>
<p>　　这个宏是用来定义需要打印的字符串的级别，值越小，级别越高。内核中有个参数用来控制是否将printk打印的字符串输出到控制台(屏幕或者/sys/log/syslog日志文件)</p>
<p>　　# cat /proc/sys/kernel/printk</p>
<p>　　6 4 1 7</p>
<p>　　第一个6表示级别高于(小于)6的消息才会被输出到控制台，第二个4表示如果调用printk时没有指定消息级别(宏)则消息的级别为4，第三个1表示接受的最高(最小)级别是1，第四个7表示系统启动时第一个6原来的初值是7。</p>
<p>　　因此，如果你发现在控制台上看不到你程序中某些printk的输出，请使用 echo 8 &gt; /proc/sys/kernel/printk  来解决。</p>
<p>　　我们在复杂驱动的开发过程中，为了调试会在源码中加入成百上千的printk语句。而当调试完毕形成最终产品的时候必然会将这些printk语句删除(为什么?想想你自己是驱动的使用者而不是开发者吧。记住：己所不欲，勿施于人)，这个工作量是不小的。最要命的是，如果我们将调试用的printk语句删除后，用户又报告我们的驱动有bug，所以我们又不得不手工将这些上千条的printk语句再重新加上。OMG，杀了我吧。所以，我们需要一种能方便地打开和关闭调试信息的手段。哪里能找到这种手段呢?哈哈，远在天边，近在眼前。看看scull驱动或者leds驱动的源代码吧!</p>
<p>　　#define LEDS_DEBUG</p>
<p>　　#undef PDEBUG</p>
<p>　　#ifdef LEDS_DEBUG</p>
<p>　　#ifdef __KERNEL__</p>
<p>　　#define PDEBUG(fmt, args…) printk( KERN_EMERG "leds: " fmt, ## args)</p>
<p>　　#else</p>
<p>　　#define PDEBUG(fmt, args…) fprintf(stderr, fmt, ## args)</p>
<p>　　#endif</p>
<p>　　#else</p>
<p>　　#define PDEBUG(fmt, args…)</p>
<p>　　#endif</p>
<p>　　#undef PDEBUGG</p>
<p>　　#define PDEBUGG(fmt, args…)</p>
<p>　　这样一来，在开发驱动的过程中，如果想打印调试消息，我们就可以用 PDEBUG("address of i_cdev is %pn",  inode-&gt;i_cdev); ，如果不想看到该调试消息，就只需要简单的将 PDEBUG 改为 PDEBUGG  即可。而当我们调试完毕形成最终产品时，只需要简单地将第1行注释掉即可。</p>
<p>　　上边那一段代码中的__KERNEL__是内核中定义的宏，当我们编译内核(包括模块)时，它会被定义。当然如果你不明白代码中的…和##是什么意思的话，就请认真查阅一下gcc关于预处理部分的资料吧!如果你实在太懒不愿意去查阅的话，那就充当VC工程师把上面的代码copy到你的代码中去吧。</p>
<p>　　二、查看OOP消息</p>
<p>　　OOP意为惊讶。当你的驱动有问题，内核不惊讶才怪：嘿!小子，你干吗乱来!好吧，让我们来看看内核是如何惊讶的。</p>
<p>　　根据 faulty.c 编译出faulty.ko，并 insmod faulty.ko。执行 echo yang &gt; /dev/faulty  ，结果内核就惊讶了。内核为什么会惊讶呢?因为faulty驱动的write函数执行了*(int *)0 = 0，向内存0地址写入，这是内核绝对不会容许的。</p>
<p>　　ssize_t faulty_write (struct file *filp, const char __user *buf, size_t  count, loff_t *pos)</p>
<p>　　{</p>
<p>　　*(int *)0 = 0;</p>
<p>　　return 0;</p>
<p>　　}</p>
<p>　　Unable to handle kernel NULL pointer dereference at virtual address  00000000</p>
<p>　　pgd = c3894000</p>
<p>　　[00000000] *pgd=33830031, *pte=00000000, *ppte=00000000</p>
<p>　　Internal error: Oops: 817 [#1] PREEMPT</p>
<p>　　Modules linked in: faulty scull</p>
<p>　　CPU: 0 Not tainted (2.6.22.6 #4)</p>
<p>　　PC is at faulty_write+0×10/0×18 [faulty]</p>
<p>　　LR is at vfs_write+0xc4/0×148</p>
<p>　　pc : [] lr : [] psr: a0000013</p>
<p>　　sp : c3871f44 ip : c3871f54 fp : c3871f50</p>
<p>　　r10: 4021765c r9 : c3870000 r8 : 00000000</p>
<p>　　r7 : 00000004 r6 : c3871f78 r5 : 40016000 r4 : c38e5160</p>
<p>　　r3 : c3871f78 r2 : 00000004 r1 : 40016000 r0 : 00000000</p>
<p>　　Flags: NzCv IRQs on FIQs on Mode SVC_32 Segment user</p>
<p>　　Control: c000717f Table: 33894000 DAC: 00000015</p>
<p>　　Process sh (pid: 745, stack limit = 0xc3870258)</p>
<p>　　Stack: (0xc3871f44 to 0xc3872000)</p>
<p>　　1f40: c3871f74 c3871f54 c0088eb8 bf00608c 00000004 c38e5180 c38e5160</p>
<p>　　1f60: c3871f78 00000000 c3871fa4 c3871f78 c0088ffc c0088e04 00000000  00000000</p>
<p>　　1f80: 00000000 00000004 40016000 40215730 00000004 c002c0e4 00000000  c3871fa8</p>
<p>　　1fa0: c002bf40 c0088fc0 00000004 40016000 00000001 40016000 00000004  00000000</p>
<p>　　1fc0: 00000004 40016000 40215730 00000004 00000001 00000000 4021765c  00000000</p>
<p>　　1fe0: 00000000 bea60964 0000266c 401adb40 60000010 00000001 00000000  00000000</p>
<p>　　Backtrace:</p>
<p>　　[] (faulty_write+0×0/0×18 [faulty]) from [] (vfs_write+0xc4/0×148)</p>
<p>　　[] (vfs_write+0×0/0×148) from [] (sys_write+0x4c/0×74)</p>
<p>　　r7:00000000 r6:c3871f78 r5:c38e5160 r4:c38e5180</p>
<p>　　[] (sys_write+0×0/0×74) from [] (ret_fast_syscall+0×0/0x2c)</p>
<p>　　r8:c002c0e4 r7:00000004 r6:40215730 r5:40016000 r4:00000004</p>
<p>　　Code: e1a0c00d e92dd800 e24cb004 e3a00000 (e5800000)</p>
<p>　　1行惊讶的原因，也就是报告出错的原因;</p>
<p>　　2-4行是OOP信息序号;</p>
<p>　　5行是出错时内核已加载模块;</p>
<p>　　6行是发生错误的CPU序号;</p>
<p>　　7-15行是发生错误的位置，以及当时CPU各个寄存器的值，这最有利于我们找出问题所在地;</p>
<p>　　16行是当前进程的名字及进程ID</p>
<p>　　17-23行是出错时，栈内的内容</p>
<p>　　24-29行是栈回溯信息，可看出直到出错时的函数递进调用关系(确保CONFIG_FRAME_POINTER被定义)</p>
<p>　　30行是出错指令及其附近指令的机器码，出错指令本身在小括号中</p>
<p>　　反汇编 faulty.ko:</p>
<p>　　arm-linux-objdump -D faulty.ko &gt; faulty.dis ;cat faulty.dis</p>
<p>　　可以看到如下的语句如下：</p>
<p>　　0000007c :</p>
<p>　　7c: e1a0c00d mov ip, sp</p>
<p>　　80: e92dd800 stmdb sp!, {fp, ip, lr, pc}</p>
<p>　　84: e24cb004 sub fp, ip, #4 ; 0×4</p>
<p>　　88: e3a00000 mov r0, #0 ; 0×0</p>
<p>　　8c: e5800000 str r0, [r0]</p>
<p>　　90: e89da800 ldmia sp, {fp, sp, pc}</p>
<p>　　定位出错位置以及获取相关信息的过程：</p>
<p>　　9 pc : [] lr : [] psr: a0000013</p>
<p>　　25 [] (faulty_write+0×0/0×18 [faulty]) from [] (vfs_write+0xc4/0×148)</p>
<p>　　26 [] (vfs_write+0×0/0×148) from [] (sys_write+0x4c/0×74)</p>
<p>　　出错代码是 faulty_write  函数中的第5条指令((0xbf00608c-0xbf00607c)/4+1=5)，该函数的首地址是0xbf00607c，该函数总共6条指令(0×18)，该函数是被0xc0088eb8的前一条指令调用的(即：函数返回地址是0xc0088eb8。这一点可以从出错时lr的值正好等于0xc0088eb8得到印证)。调用该函数的指令是vfs_write的第49条(0xc4/4=49)指令。</p>
<p>　　达到出错处的函数调用流程是：write(用户空间的系统调用) –&gt; sys_write –&gt; vfs_write -&gt;  faulty_write .</p>
<p>　　OOP消息不仅让我定位了出错的地方，更让我惊喜的是，它让我知道了一些秘密：1、gcc中fp到底有何用处?2、为什么gcc编译任何函数的时候，总是要把3条看上去傻傻的指令放在整个函数的最开始?3、内核和gdb是如何知道函数调用栈顺序，并使用函数的名字而不是地址?  4、我如何才能知道各个函数入栈的内容?哈哈，我渐渐喜欢上了让内核惊讶，那就再看一次内核惊讶吧。</p>
<p>　　执行 cat /dev/faulty，内核又再一次惊讶!</p>
<p>　　1 Unable to handle kernel NULL pointer dereference at virtual address  0000000b</p>
<p>　　2 pgd = c3a88000</p>
<p>　　3 [0000000b] *pgd=33a79031, *pte=00000000, *ppte=00000000</p>
<p>　　4 Internal error: Oops: 13 [#2] PREEMPT</p>
<p>　　5 Modules linked in: faulty</p>
<p>　　6 CPU: 0 Not tainted (2.6.22.6 #4)</p>
<p>　　7 PC is at vfs_read+0xe0/0×140</p>
<p>　　8 LR is at 0xffffffff</p>
<p>　　9 pc : [] lr : [] psr: 20000013</p>
<p>　　10 sp : c38d9f54 ip : 0000001c fp : ffffffff</p>
<p>　　11 r10: 00000001 r9 : c38d8000 r8 : 00000000</p>
<p>　　12 r7 : 00000004 r6 : ffffffff r5 : ffffffff r4 : ffffffff</p>
<p>　　13 r3 : ffffffff r2 : 00000000 r1 : c38d9f38 r0 : 00000004</p>
<p>　　14 Flags: nzCv IRQs on FIQs on Mode SVC_32 Segment user</p>
<p>　　15 Control: c000717f Table: 33a88000 DAC: 00000015</p>
<p>　　16 Process cat (pid: 767, stack limit = 0xc38d8258)</p>
<p>　　17 Stack: (0xc38d9f54 to 0xc38da000)</p>
<p>　　18 9f40: 00002000 c3c105a0 c3c10580</p>
<p>　　19 9f60: c38d9f78 00000000 c38d9fa4 c38d9f78 c0088f88 c0088bb4 00000000  00000000</p>
<p>　　20 9f80: 00000000 00002000 bef07c80 00000003 00000003 c002c0e4 00000000  c38d9fa8</p>
<p>　　21 9fa0: c002bf40 c0088f4c 00002000 bef07c80 00000003 bef07c80 00002000  00000000</p>
<p>　　22 9fc0: 00002000 bef07c80 00000003 00000000 00000000 00000001 00000001  00000003</p>
<p>　　23 9fe0: 00000000 bef07c6c 0000266c 401adab0 60000010 00000003 00000000  00000000</p>
<p>　　24 Backtrace: invalid frame pointer 0xffffffff</p>
<p>　　25 Code: ebffff86 e3500000 e1a07000 da000015 (e594500c)</p>
<p>　　26 Segmentation fault</p>
<p>　　不过这次惊讶却令人大为不解。OOP竟然说出错的地方在vfs_read(要知道它可是大拿们千锤百炼的内核代码)，这怎么可能?哈哈，万能的内核也不能追踪函数调用栈了，这是为什么?其实问题出在faulty_read的43行，它导致入栈的r4、r5、r6、fp全部变为了0xffffffff，ip、lr的值未变，这样一来faulty_read函数能够成功返回到它的调用者——vfs_read。但是可怜的vfs_read(忠实的APTCS规则遵守者)并不知道它的r4、r5、r6已经被万恶的faulty_read改变，这样下去vfs_read命运就可想而知了——必死无疑!虽然内核很有能力，但缺少了正确的fp的帮助，它也无法追踪函数调用栈。</p>
<p>　　ssize_t faulty_read(struct file *filp, char __user *buf,</p>
<p>　　size_t count, loff_t *pos)</p>
<p>　　{</p>
<p>　　int ret;</p>
<p>　　char stack_buf[4];</p>
<p>　　memset(stack_buf, 0xff, 20);</p>
<p>　　if (count &gt; 4)</p>
<p>　　count = 4;</p>
<p>　　ret = copy_to_user(buf, stack_buf, count);</p>
<p>　　if (!ret)</p>
<p>　　return count;</p>
<p>　　return ret;</p>
<p>　　}</p>
<p>　　00000000 :</p>
<p>　　0: e1a0c00d mov ip, sp</p>
<p>　　4: e92dd870 stmdb sp!, {r4, r5, r6, fp, ip, lr, pc}</p>
<p>　　8: e24cb004 sub fp, ip, #4 ; 0×4</p>
<p>　　c: e24dd004 sub sp, sp, #4 ;  0×4，这里为stack_buf[]在栈上分配1个字的空间，局部变量ret使用寄存器存储，因此就不在栈上分配空间了</p>
<p>　　10: e24b501c sub r5, fp, #28 ; 0x1c</p>
<p>　　14: e1a04001 mov r4, r1</p>
<p>　　18: e1a06002 mov r6, r2</p>
<p>　　1c: e3a010ff mov r1, #255 ; 0xff</p>
<p>　　20: e3a02014 mov r2, #20 ; 0×14</p>
<p>　　24: e1a00005 mov r0, r5</p>
<p>　　28: ebfffffe bl 28 //这里在调用memset</p>
<p>　　78: e89da878 ldmia sp, {r3, r4, r5, r6, fp, sp, pc}</p>
<p>　　这次OOP，让我深刻地认识到：</p>
<p>　　内核能力超强，但它不是，也不可能是万能的。所以即使你能力再强，也要和你的team member搞好关系，否则在关键时候你会倒霉的;</p>
<p>　　出错的是faulty_read，vfs_read却做了替罪羊。所以人不要被表面现象所迷惑，要深入看本质;</p>
<p>　　内核本来超级健壮，可是你写的驱动是内核的组成部分，由于它出错，结果整体崩盘。所以当你加入一个团队的时候一定要告诫自己，虽然你的角色也许并不重要，但你的疏忽大意将足以令整个非常牛X的团队崩盘。反过来说，当你是team  leader的时候，在选团队成员的时候一定要慎重、慎重、再慎重，即使他只是一个小角色。</p>
<p>　　千万别惹堆栈，它一旦出问题，定位错误将会是一件非常困难的事情。所以，千万别惹你的领导，否则你将死得很难看。</p>
<p>　　三、利用strace</p>
<p>　　有时小问题可以通过监视程序监控用户应用程序的行为来追踪，同时监视程序也有助于建立对驱动正确工作的信心。例如，在看了它的读实现如何响应不同数量数据的读请求之后，我们能够对scull正在正确运行感到有信心。</p>
<p>　　有几个方法来监视用户空间程序运行。你可以运行一个调试器来单步过它的函数，增加打印语句，或者在 strace  下运行程序。这里，我们将讨论最后一个技术，因为当真正目的是检查内核代码时，它是最有用的。</p>
<p>　　strace 命令是一个有力工具，它能显示所有的用户空间程序发出的系统调用。它不仅显示调用，还以符号形式显示调用的参数和返回值。当一个系统调用失败,  错误的符号值(例如, ENOMEM)和对应的字串(Out of memory) 都显示。strace 有很多命令行选项，其中最有用的是 -t  来显示每个调用执行的时间，-T 来显示调用中花费的时间，-e 来限制被跟踪调用的类型(例如strace –eread,write  ls表示只监控read和write调用)，以及-o 来重定向输出到一个文件。缺省情况下，strace 打印调用信息到 stderr。</p>
<p>　　strace 从内核自身获取信息。这意味着可以跟踪一个程序，不管它是否带有调试支持编译(对 gcc 是 -g  选项)以及不管它是否被strip过。此外，你也可以追踪一个正在运行中的进程，这类似于调试器连接到一个运行中的进程并控制它。</p>
<p>　　跟踪信息常用来支持发给应用程序开发者的故障报告，但是对内核程序员也是很有价值的。我们已经看到驱动代码运行如何响应系统调用，strace  允许我们检查每个调用的输入和输出数据的一致性。</p>
<p>　　例如，运行命令 strace ls /dev &gt; /dev/scull0 将会在屏幕上显示如下的内容：</p>
<p>　　open("/dev", O_RDONLY|O_NONBLOCK|O_LARGEFILE|O_DIRECTORY) = 3</p>
<p>　　fstat64(3, {st_mode=S_IFDIR|0755, st_size=24576, …}) = 0</p>
<p>　　fcntl64(3, F_SETFD, FD_CLOEXEC) = 0</p>
<p>　　getdents64(3, , 4096) = 4088</p>
<p>　　[...]</p>
<p>　　getdents64(3, , 4096) = 0</p>
<p>　　close(3) = 0</p>
<p>　　[...]</p>
<p>　　fstat64(1, {st_mode=S_IFCHR|0664, st_rdev=makedev(254, 0), …}) = 0</p>
<p>　　write(1, "MAKEDEVnadmmidi0nadmmidi1nadmmid"…, 4096) = 4000</p>
<p>　　write(1, "bnptywcnptywdnptywenptywfnptyx0n"…, 96) = 96</p>
<p>　　write(1, "bnptyxcnptyxdnptyxenptyxfnptyy0n"…, 4096) = 3904</p>
<p>　　write(1, "s17nvcs18nvcs19nvcs2nvcs20nvcs21"…, 192) = 192</p>
<p>　　write(1, "nvcs47nvcs48nvcs49nvcs5nvcs50nvc"…, 673) = 673</p>
<p>　　close(1) = 0</p>
<p>　　exit_group(0) = ?</p>
<p>　　从第一个 write 调用看, 明显地, 在 ls 结束查看目标目录后，它试图写 4KB。但奇怪的是，只有 4000 字节被成功写入,  并且操作被重复。但当我们查看scull 中的写实现，发现它一次最多只允许写一个quantum(共4000字节)，可见驱动本来就是期望部分写。几步之后,  所有东西清空, 程序成功退出。正是通过strace的输出，使我们确信驱动的部分写功能运行正确。</p>
<p>　　作为另一个例子, 让我们读取 scull 设备(使用 wc scull0 命令):</p>
<p>　　[...]</p>
<p>　　open("/dev/scull0", O_RDONLY|O_LARGEFILE) = 3</p>
<p>　　fstat64(3, {st_mode=S_IFCHR|0664, st_rdev=makedev(254, 0), …}) = 0</p>
<p>　　read(3, "MAKEDEVnadmmidi0nadmmidi1nadmmid"…, 16384) = 4000</p>
<p>　　read(3, "bnptywcnptywdnptywenptywfnptyx0n"…, 16384) = 4000</p>
<p>　　read(3, "s17nvcs18nvcs19nvcs2nvcs20nvcs21"…, 16384) = 865</p>
<p>　　read(3, "", 16384) = 0</p>
<p>　　fstat64(1, {st_mode=S_IFCHR|0620, st_rdev=makedev(136, 1), …}) = 0</p>
<p>　　write(1, "8865 /dev/scull0n", 17) = 17</p>
<p>　　close(3) = 0</p>
<p>　　exit_group(0) = ?</p>
<p>　　如同期望的, read 一次只能获取 4000 字节，但是数据总量等同于前个例子写入的。这个例子，意外的收获是：可以肯定，wc  为快速读进行了优化，它因此绕过了标准库(没有使用fscanf)，而是直接一个系统调用以读取更多数据。这一点，可从跟踪到的读的行里看到wc一次试图读取16  KB的数据而确认。</p>
<p>　　四、利用ioctl方法</p>
<p>　　由于驱动中的ioctl函数可以将驱动的一些信息返回给用户程序，也可以让用户程序通过ioctl系统调用设置一些驱动的参数。所以在驱动的开发过程中，可以扩展一些ioctl的命令用于传递和设置调试驱动时所需各种信息和参数，以达到调试驱动的目的。</p>
<p>　　五、利用/proc 文件系统</p>
<p>　　/proc文件系统用于内核向用户空间暴露一些内核的信息。因此出于调试的目的，我们可以在驱动代码中增加向/proc文件系统导出有助于监视驱动的信息的代码。这样一来，我们就可以通过查看/proc中的相关信息来监视和调试驱动。如何在驱动中实现向/proc文件系统导出信息，请参见《Linux  Device Driver》的4.3节。</p>
<p>　　六、使用kgdb</p>
<p>　　kgdb是在内核源码中打用于调试内核的补丁，然后通过相应的硬件和软件，就可以像gdb单步调试应用程序一样来调试内核(当然包括驱动)。至于kgdb如何使用，就请你google吧，实在不行，百度一下也可以。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 14:06:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e9%a9%b1%e5%8a%a8/" title="驱动">驱动</a>, <a href="https://www.iamivan.net/tag/%e5%86%85%e6%a0%b8/" title="内核">内核</a>, <a href="https://www.iamivan.net/tag/kgdb/" title="kgdb">kgdb</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e8%af%91%e5%86%85%e6%a0%b8%e5%87%ba%e9%94%99/" title="编译内核出错">编译内核出错</a>, <a href="https://www.iamivan.net/tag/r%e6%96%87%e4%bb%b6%e5%87%ba%e9%94%99/" title="r文件出错">r文件出错</a>, <a href="https://www.iamivan.net/tag/eread/" title="eREAD">eREAD</a>, <a href="https://www.iamivan.net/tag/printk/" title="printk">printk</a>, <a href="https://www.iamivan.net/tag/%c2%a0hresult%ef%bc%9a0xc00d1054/" title="&num;&nbsp;HRESULT：0xC00D1054">&num;&nbsp;HRESULT：0xC00D1054</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux系统驱动开发调试技术指南的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLYN7Wz.html" rel="bookmark">Linux系统驱动开发调试技术指南教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.使用printk 这是驱动开发中最朴实无华,同时也是最常用和有效的手段.scull驱动的main.c第338行如下,就是使用printk进行调试的例子,这样的例子相信大家在阅读驱动源码时随处可见. printk(KERN_ALERT &quot;wakeup by signal in process %dn&quot;, current-&gt;;pid); printk的功能与我们经常在应用程序中使用的printf是一样的,不同之处在于printk可以在打印字符串前面加上内核定义的宏,例如上面例子中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqR0P3p.html" rel="bookmark">Linux c c&plus;&plus; 开发调试技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看到一篇介绍 linux c/c++ 开发调试技巧的文章,感觉挺使用,哪来和大家分享.  通向 UNIX 天堂的 10 个阶梯Author: Arpan Sen, 高级技术人员, Systems Documentation, Inc. (SDI) 讨论几种可以帮助 C++ 开发人员节省时间的技巧和免费工具.  C++ 开发人员在日常工作中通常要完成多个任务:开发新软件.调试其他人的代码.制订测试计划.为每个计划开发测试.管理衰退软件(regression suite)等等.在多种角色之间频繁转换			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NLwJM.html" rel="bookmark">《Linux 设备驱动开发详解（第2版）》&mdash;&mdash;1&period;6 设备驱动Hello World：LED驱动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.6 设备驱动Hello World:LED驱动 Linux 设备驱动开发详解(第2版)1.6.1 无操作系统时的LED驱动 在嵌入式系统的设计中,LED一般直接由CPU的GPIO(通用可编程I/O口)控制.GPIO一般由两组寄存器控制,即一组控制寄存器和一组数据寄存器.控制寄存器可设置GPIO口的工作方式为输入或是输出.当引脚被设置为输出时,向数据寄存器的对应位写入1和0会分别在引脚上产生高电平和低电平:当引脚设置为输入时,读取数据寄存器的对应位可获得引脚上的电平为高或低. 在本例子中,我们			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnKErOz.html" rel="bookmark">《Linux 设备驱动开发详解（第2版）》&mdash;&mdash;1&period;4 Linux设备驱动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 Linux设备驱动 Linux 设备驱动开发详解(第2版)1.4.1 设备的分类及特点 计算机系统的硬件主要由CPU.存储器和外设组成.随着IC制作工艺的发展,目前,芯片的集成度越来越高,往往在CPU内部就集成了存储器和外设适配器.譬如,相当多的ARM.PowerPC.MIPS等处理器都集成了UART.I2C控制器.USB控制器.SDRAM控制器等,有的处理器还集成了片内RAM和Flash. 驱动针对的对象是存储器和外设(包括CPU内部集成的存储器和外设),而不是针对CPU核.Linux			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOWQ8vz.html" rel="bookmark">《Linux 设备驱动开发详解（第2版）》&mdash;&mdash;1&period;3 有操作系统时的设备驱动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 有操作系统时的设备驱动 Linux 设备驱动开发详解(第2版)1.2节中我们看到一个干净利落的设备驱动,它直接运行在硬件之上,不与任何操作系统关联.当系统中包含操作系统后,设备驱动会变得怎样? 首先,无操作系统时设备驱动的硬件操作工作仍然是必不可少的,没有这一部分,驱动不可能与硬件打交道. 其次,我们还需要将驱动融入内核.为了实现这种融合,必须在所有设备的驱动中设计面向操作系统内核的接口,这样的接口由操作系统规定,对一类设备而言结构一致,独立于具体的设备. 由此可见,当系统中存在操作系统			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bByvNJz.html" rel="bookmark">《Linux设备驱动开发详解 A》一一第１章 Linux设备驱动概述及开发环境构建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 Linux设备驱动概述及开发环境构建本章导读本章将介绍Linux设备驱动开发的基本概念,并对本书所基于的平台和开发环境进行讲解.1.1节阐明设备驱动的概念和作用.1.2节和1.3节分别讲解在无操作系统情况下和有操作系统情况下设备驱动的设计,通过对设计差异的分析,讲解设备驱动与硬件和操作系统的关系.1.4节对Linux操作系统的设备驱动进行了概要性的介绍,给出设备驱动与整个软硬件系统的关系,分析Linux设备驱动的重点.难点和学习方法.1.5节对本书所基于的QEMU模拟的vexpress			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEJoPZM.html" rel="bookmark">《Linux 设备驱动开发详解（第2版）》&mdash;&mdash;1&period;2 无操作系统时的设备驱动</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 无操作系统时的设备驱动 Linux 设备驱动开发详解(第2版)并不是任何一个计算机系统都一定要运行操作系统,在许多情况下,操作系统都不必存在.对于功能比较单一.控制并不复杂的系统,譬如ASIC内部.公交车的刷卡机.电冰箱.微波炉.简单的手机和小灵通等,并不需要多任务调度.文件系统.内存管理等复杂功能,用单任务架构完全可以良好地支持它们的工作.一个无限循环中夹杂对设备中断的检测或者对设备的轮询是这种系统中软件的典型架构,如代码清单1.1. 代码清单1.1 单任务软件典型架构 1 int m			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMl5rDp.html" rel="bookmark">VC文件过滤系统驱动开发Filemon学习笔记</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				WINDOWS文件过滤系统驱动开发,可用于硬盘还原,防病毒,文件安全防护,文件加密 等诸多领域.而掌握核心层的理论及实践,对于成为一名优秀的开发人员不可或缺. WINDOWS文件过滤系统驱动开发的两个经典例子,Filemon与SFilter,初学者在经 过一定的理论积累后,对此两个例子代码的研究分析,会是步入驱动开发殿堂的重要一步 ,相信一定的理论积累以及贯穿剖析理解此两个例程后,就有能力开始进行文件过滤系统 驱动开发的实际工作了. 对于SFilter例子的讲解,楚狂人的教程已经比较流行, 而F			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZE176p.html" rel="bookmark">《Linux 设备驱动开发详解（第2版）》&mdash;&mdash;导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本书第1版在2008年初出版以后,受到广大读者的支持和厚爱,累计销售1.6万册,从几年的市场和读者反馈看,在第1版中还存在一些不足,主要是以下几方面. 没有现成的开发环境,读者需要从头到尾构建,而构建需要花费很长的时间,许多时候会不成功,加之配套光盘中的实例没有Makefile,更加大了操作的难度. 没有配套的开发板,大量的基于S3C2410的实例读者身边如果没有可以直接运行的平台,就无法亲身体验这些驱动. 个别内容实用性不强或过于陈旧,也有个别知识点的讲解语言晦涩,读者不易理解,如pla			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MY5V5M.html" rel="bookmark" class="title">struts2&period;0-在struts2中用什么替代&amp;amp&semi;amp&semi;lt&semi;logic&colon;notPresent&amp;amp&semi;amp&semi;gt&semi;</a>
					<div>
						问题描述 在struts2中用什么替代&lt;logic:notPresent&gt; &lt;logic:notPresent name=&quot;class${classSingle.class ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvZNVM.html" rel="bookmark" class="title">ASP生成静态Html文件技术杂谈</a>
					<div>
						静态 网页生成静态Html文件有许多好处,比如生成html网页有利于被收录,不仅被收录的快还收录的全.前台脱离了数据访问,减轻对访问的压力,加快网页打开速度.像www.aspid.cn的主站就采用了T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp83o9M.html" rel="bookmark" class="title">SEO从业人员不要&OpenCurlyDoubleQuote;虎&rdquo;</a>
					<div>
						SEO这个行业发展到现在早已经不是个人英雄的时代了,个人站长的网站不论从SEO还是网站用户体验都有了质的发展,更不用说大型网站的发展了.那么怎样在将来的SEO这个行业中发展并有所建树呢?答案是SEO从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2Nj5p.html" rel="bookmark" class="title">Hyper-V的动态内存&lpar;Dynamic Memory&rpar;</a>
					<div>
						Hyper-V不支持Memory Overcommitment,一直为VMware和其他虚拟化厂商所诟病.当然,微软一直不承认这是他们的软肋,认为为了保证生产环境VM的性能,过量分配内存是不合时宜的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx8dWb.html" rel="bookmark" class="title">SharePoint 2010文档管理：星级评论功能</a>
					<div>
						正如我们前面介绍的是,文档管理就是让大家更加直观.方便的对手里的文档,进行统筹掌控,哪些文档是有价值的,哪些文档更受大家欢迎,所有就带来了这个星级评论. 当然,这个是SharePoint 2010自带 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bElyj9z.html" rel="bookmark" class="title">atomic与nonatomic，assign copy与retain的区别</a>
					<div>
						  atomic和nonatomic用来决定编译器生成的getter和setter是否为原子操作. atomic 设置成员变量的@property属性时,默认为atomic,提供多线程安全. 在多线程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wDx9p.html" rel="bookmark" class="title">sql判断null Oracle&comma;sql server</a>
					<div>
						  sql server 替换null:isnull(arg,value) 如:select isnull(price,0.0) from orders ,如果price为null的话,用0.0替换  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN3WDb.html" rel="bookmark" class="title">PhotoShop中加深减淡工具的使用入门教程</a>
					<div>
						在Photoshop 以前版本中,在想要减淡和加深时,必须做大量的操作(创建专用图层,使用混合模式等),因为减淡和加深工具不是那么好.幸运的是,Adobe 已经更新了这些工具,问题得到彻底改变,现在可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOlnkb.html" rel="bookmark" class="title">虎扑直播设计思路</a>
					<div>
						  前言:虎扑一直觉得视觉做的不好,很多细节体验也不好,但是真离不开它,原因在于几年web端的经营,聚集了大量优质用户,这些用户的创造的氛围也是虎扑区别市面上其它app最重要的特点没有之一,而根据这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z422xLM.html" rel="bookmark" class="title">中华通电脑上通话没有声音怎么办？</a>
					<div>
						  一 先检查本地硬件设备问题,耳麦或者选择本地录音文件播放是否正常.可以打客服800测试,如果没有声音有可能是网络端口有阻挡或者是声卡驱动问题. 二.硬件设备检查正常时,按下面步骤操作设置: 1.检 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY7xjM.html" rel="bookmark" class="title">Excel怎么把两张工作表进行对比？</a>
					<div>
						  前几天高考小长假,老师让我做一个下周班级挑战赛的PPT,有一个项是:退步惊人的学生(我班的和他们班的),老师只给了我们班的,而没有给他们班的,只不过有几张电子表(关于成绩的,以上所说都是关于上期末 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP81Emp.html" rel="bookmark" class="title">BIOS中怎么设置定时开机</a>
					<div>
						  设置定时开机后,电脑每天自动开启,可以在BIOS中进行设置.那么,怎么设置定时开机呢? 在进入BIOS后,选择Power Management Setup按[Enter],然后选择PM Wake  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWj5Lp.html" rel="bookmark" class="title">百度钱包怎么充值</a>
					<div>
						  1.百度搜索&quot;百度钱包&quot;,进入输入百度账号 2.然后点击下面的&quot;充值&quot; 3.这里首先需要我们下载控件,下载安装成功后才可以填写信息,如图:(已经安装成功控件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8EJ2b.html" rel="bookmark" class="title">iOS和OS X&colon;wifi路由器怎么设置</a>
					<div>
						  Wi-Fi 基站为 802.11a/b/g/n 接入点,包括 AirPort Extreme 基站.AirPort Express 和 AirPort Time Capsule.&quot;Wi- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWLa7b.html" rel="bookmark" class="title">php 把对象转化为json</a>
					<div>
						php中如何把对象转化为json呢? (1)对于普通的php对象 Php代码    //convert object to array   function object_to_array($obj) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN8QKM.html" rel="bookmark" class="title">中文技术文档的写作规范</a>
					<div>
						很多人说,不知道怎么写文档,都是凭着感觉写. 网上也很少有资料,教你写文档.这已经影响了中文软件的发展. 英语世界里,文档非常受重视,许多公司和组织都有自己的文档规范,清楚地规定写作要求,比如微软.M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3DwPz.html" rel="bookmark" class="title">PC行业为何需要华为们被搅局？</a>
					<div>
						伴随&quot;MateBook is coming&quot;海报曝光,华为笔记本终于确定将于5月26日开售,传统PC领域的&quot;鲶鱼&quot;真的来了. 华为进入笔记本产品传言始于2012 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pgovp.html" rel="bookmark" class="title">hibernate生成的dao，调用他查询，我初学，麻烦帮忙看一下</a>
					<div>
						问题描述 public List findAll() {log.debug(&quot;finding all User instances&quot;);try {String queryStrin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKK4Zz.html" rel="bookmark" class="title">ORA-01078&colon; failure in processing system parameters &amp;amp&semi; LRM-00109&colon; could not open parameter file</a>
					<div>
						安装了Oracle 12C后,启动数据库的过程中出现如下错误 SQL&gt; startup ORA-01078: failure in processing system parameters LR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlGqEp.html" rel="bookmark" class="title">VMware Workstation and Hyper-V are not compatible&period; 解决方案</a>
					<div>
						VMware 和 Hyper-V 不能共存问题 报错如下: VMware Workstation and Hyper-V are notcompatible. Remove the Hyper-V r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0W8yp.html" rel="bookmark" class="title">LOL每周免费英雄更新 不祥之刃卡特琳娜登场</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;   [科技讯]1月4日消息,LOL每周免费英雄将于明日更新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLkVYM.html" rel="bookmark" class="title">《操作系统真象还原》&mdash;&mdash;0&period;18 编译型程序与解释型程序的区别</a>
					<div>
						0.18 编译型程序与解释型程序的区别 解释型语言,也称为脚本语言,如JavaScript.Python.Perl.PHP.Shell脚本等.它们本身是文本文件,是某个应用程序的输入,这个应用程序是脚 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0RlVp.html" rel="bookmark" class="title">preg&lowbar;match正则匹配的字符串</a>
					<div>
						例 preg_match_all正则匹配字符串所有连接地址  代码如下 复制代码 $str ='&lt;a href=&quot;http://www.a.com/2010/11-15/5.html& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmNDap.html" rel="bookmark" class="title">Windows 10 S 系统确认不允许挂载 Linux 分支</a>
					<div>
						微软日前宣布,将在Windows商店分发Liunx分支版系统,比如Ubuntu.SUSE Linux等,也就是说,Windows 10用户可以从商店下载安装. 消息传出后,不少网友联系到了此前发布的W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLBQ4Wb.html" rel="bookmark" class="title">高性能计算用户大会在北京举行</a>
					<div>
						近日,2013高性能计算用户大会在北京举行.天河二号主任设计师.国防科学技术大学卢宇彤教授在大会报告中详细揭秘了天河二号的系统架构和创新应用,披露了我国超算的自主研发实力水平,提高了大家对中国超算自主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqg56p.html" rel="bookmark" class="title">【25】实现一个含有min函数的栈的通用模板</a>
					<div>
						题目:设计一个栈类型,使得在该栈类型中有一个函数min可以得到栈的最小元素,要求这个栈的push.pop.min都是O(1). 分析: 1. 栈的性质是先进后出,因此一般情况下栈的push.pop的时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx2L1jz.html" rel="bookmark" class="title">动视暴雪：Zynga颠覆者 未跟风社交游戏</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 导语:国外媒体今天撰文称,虽然曾经引领了社交游戏风潮,但Zynga如今已经江河日下,当年通过并购追赶这一趋势的EA和迪士尼也遭到了冲击.在如此颓势下,一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0NqaM.html" rel="bookmark" class="title">FTP和SSH无法&period;htaccess文件的解决方法</a>
					<div>
						ssh中不显示htaccess解决办法 LeapFTP设置方法: 1.点开&quot;选项&quot;菜单,选择&quot;参数&quot;-&quot;常规&quot;,打开&quot;参数设置&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKllvz.html" rel="bookmark" class="title">2015&comma;联通很忙</a>
					<div>
						联通很忙. 近年来,电信运营商收入增长面临瓶颈.基层考核压力日增.部分联通基层业务人员借助他人身份信息办理业务成为公开的秘密. &lt;第一财经日报&gt;记者获得的多封联通内部邮件显示,湖南省部分市 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgWPKBM.html" rel="bookmark" class="title">物联网技术为企业发展提供新突破口</a>
					<div>
						我国今年将要实施,在今年的全国人大三次会议上,国务院总理李克强在政府工作报告中提出&quot;互联网+&quot;行动计划,以推动移动互联网.云计算.大数据.物联网等与现代制造业结合.从&quot;两 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.044 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
